//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
//---------------------------------------------------------------------------

 USERES("dxsoftex.res");
//---------------------------------------------------------------------------
#define RX_BUFF_SIZE 2048
#define TX_BUFF_SIZE 2048


 struct Exchange_Struct
  {
   unsigned char RxBuffer[RX_BUFF_SIZE];
   unsigned char TxBuffer[TX_BUFF_SIZE];
   unsigned int RxHead;
   unsigned int RxTail;
   unsigned int TxHead;
   unsigned int TxTail;
   unsigned int Signature;
  } ;

 struct Exchange_Struct *Exch;

 static LPVOID lpvMem = NULL; // pointer to shared memory
 static HANDLE hMapObject = NULL;  // handle to file mapping
 static int IsInited=0; // Init flag

 //---------------------------------------------------------------------------
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{



    switch (reason)
    {
        // The DLL is loading due to process
        // initialization or a call to LoadLibrary.

          case DLL_PROCESS_ATTACH:
            break;

        // The attached process creates a new thread.

        case DLL_THREAD_ATTACH:
            break;

        // The thread of the attached process terminates.

        case DLL_THREAD_DETACH:
            break;

        // The DLL is unloading from a process due to
        // process termination or a call to FreeLibrary.

        case DLL_PROCESS_DETACH:
            // Unmap shared memory from the process's address space.
            if(lpvMem!=NULL) UnmapViewOfFile(lpvMem);
            // Close the process's handle to the file-mapping object.
            if(hMapObject!=NULL) CloseHandle(hMapObject);
            break;

        default:
          break;
     }

    return TRUE;
    // UNREFERENCED_PARAMETER(hinstDLL);
    // UNREFERENCED_PARAMETER(lpvReserved);
}


//---------------------------------------------------------------------------
// This function is called by both programs
extern "C" __declspec(dllexport) int DxsoftExchangeInit(int canal_number)
{
    BOOL fInit;
    static char str[40];

 //  " "   
 //  TRUE  , FALSE -  


    // Unmap shared memory from the process's address space.
    if(lpvMem!=NULL) {UnmapViewOfFile(lpvMem);lpvMem=NULL;}
    // Close the process's handle to the file-mapping object.
    if(hMapObject!=NULL) {CloseHandle(hMapObject);hMapObject=NULL;}
    IsInited=0;

 // Create a named file mapping object.

    wsprintf(str,"dxsoftexchange-filemap-%x",canal_number);

    hMapObject = CreateFileMapping(
        (HANDLE) 0xFFFFFFFF, // use paging file
        NULL,                // no security attributes
        PAGE_READWRITE,      // read/write access
        0,                   // size: high 32-bits
        sizeof(struct Exchange_Struct),           // size: low 32-bits
        str);    // name of map object
        if (hMapObject == NULL)
        return FALSE;

    // The first process to attach initializes memory.

    fInit = (GetLastError() != ERROR_ALREADY_EXISTS);

    // Get a pointer to the file-mapped shared memory.

    lpvMem = MapViewOfFile(

        hMapObject,     // object to map view of
        FILE_MAP_WRITE, // read/write access
        0,              // high offset:  map from
        0,              // low offset:   beginning
        0);             // default: map entire file
    if (lpvMem == NULL)
        return FALSE;

    // Initialize memory if this is the first process.

    if (fInit)
       {
        memset(lpvMem, '\0', sizeof(struct Exchange_Struct));
        Exch= (struct Exchange_Struct*) lpvMem;
        Exch->RxHead=0;
        Exch->RxTail=0;
        Exch->TxHead=0;
        Exch->TxTail=0;
       }
    else
       {
        Exch= (struct Exchange_Struct*) lpvMem;
       }

  IsInited=1;
  return TRUE;
}
//---------------------------------------------------------------------------
// There are functions called by external software
//---------------------------------------------------------------------------
extern "C" __declspec(dllexport) int DxsoftGetSymFromRxBuffer(void)
 {
  // returns received symbol or -1,
  // if buffer is empty
  int sym;

  if(!IsInited) return -1;

  if(Exch->RxHead == Exch->RxTail) return -1;

  sym=Exch->RxBuffer[Exch->RxTail]&255;
  Exch->RxTail=  (Exch->RxTail+1)&(RX_BUFF_SIZE-1);
  return sym;
 }

//---------------------------------------------------------------------------
extern "C" __declspec(dllexport) int DxsoftPutSymToTxBuffer(char sym)
 {
  // Puts symbol to TX buffer
  // return 1 if OK,
  // 0 if ERROR (buffer is full)
  int len;

  if(!IsInited) return 0;

  len =  (Exch->TxHead - Exch->TxTail)&(TX_BUFF_SIZE-1);
  if(len>(TX_BUFF_SIZE-4)) return 0;

  Exch->TxBuffer[Exch->TxHead]=sym;
  Exch->TxHead=  (Exch->TxHead+1)&(TX_BUFF_SIZE-1);

  return 1;
 }

//---------------------------------------------------------------------------
// There are functions, called by TrueTTY
//---------------------------------------------------------------------------
extern "C" __declspec(dllexport) int DxsoftGetSymFromTxBuffer(void)
 {
  // Returns symbol from TX buffer
  // Returns -1 if buffer is empty
  int sym;

  if(!IsInited) return -1;

  if(Exch->TxHead == Exch->TxTail) return -1;

  sym=Exch->TxBuffer[Exch->TxTail]&255;
  Exch->TxTail=  (Exch->TxTail+1)&(TX_BUFF_SIZE-1);
  return sym;
 }
//---------------------------------------------------------------------------
extern "C" __declspec(dllexport) int DxsoftPutSymToRxBuffer(char sym)
 {
  // Puts symbol to RX buffer
  // Returns 1 if OK,
  // returns 0 if error (buffer is full)
  int len;

  if(!IsInited) return 0;

  len =  (Exch->RxHead - Exch->RxTail)&(RX_BUFF_SIZE-1);
  if(len>(RX_BUFF_SIZE-4)) return 0;

  Exch->RxBuffer[Exch->RxHead]=sym;
  Exch->RxHead=  (Exch->RxHead+1)&(RX_BUFF_SIZE-1);

  return 1;
 }
//---------------------------------------------------------------------------


